Object subclass: #NamedObjectHome
	instanceVariableNames: 'objectDict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!NamedObjectHome commentStamp: 'MU 11/12/2000 01:30' prior: 0!
I am used for tiny naming service. Currently I just delegate requests to dictionary.
I should do some remote garbage collection.!


!NamedObjectHome methodsFor: 'initialize-release' stamp: 'mu 10/30/2000 14:37'!
initialize
	objectDict := IdentityDictionary new! !


!NamedObjectHome methodsFor: 'actions' stamp: 'mu 10/30/2000 14:49'!
at: aSymbol
	^ objectDict at: aSymbol ifAbsent:[Transcript cr; show: '##no such named object']! !

!NamedObjectHome methodsFor: 'actions' stamp: 'mu 10/30/2000 14:40'!
at: aSymbol ifAbsent: aBlock
	^ objectDict at: aSymbol ifAbsent: aBlock! !

!NamedObjectHome methodsFor: 'actions' stamp: 'mu 10/30/2000 14:38'!
at: aSymbol put: anObject 
	^ objectDict at: aSymbol put: anObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NamedObjectHome class
	instanceVariableNames: 'default '!

!NamedObjectHome class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:29'!
new
	^super new initialize! !


DataStream subclass: #OperaObjectStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaObjectStream commentStamp: 'MU 11/12/2000 01:37' prior: 0!
Simple object stream. Actually, I inherit main features from DataStream.
Language independent marshaling/unmarshaling stream will be needed.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaObjectStream class
	instanceVariableNames: ''!

!OperaObjectStream class methodsFor: 'marshal/unmarshal' stamp: 'MU 11/7/2000 16:58'!
objectFromString: aString
	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := self on: byteStr.
	^oStr next! !

!OperaObjectStream class methodsFor: 'marshal/unmarshal' stamp: 'MU 11/9/2000 11:57'!
stringFromObject: anObject 
	| file con |
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	(self on: file)
		nextPut: anObject.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^ con contents! !


Object subclass: #OperaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaSingleton commentStamp: 'MU 11/12/2000 01:50' prior: 0!
I am an abstract class for singleton. I also have some utilities.!


!OperaSingleton methodsFor: 'initialize-release' stamp: 'MU 11/5/2000 00:06'!
initialize
	"default do nothing"! !


!OperaSingleton methodsFor: 'constants' stamp: 'MU 11/7/2000 17:28'!
parser
	"current not best but most standard Xml parser"
	^VWXMLXMLParser! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaSingleton class
	instanceVariableNames: 'default '!

!OperaSingleton class methodsFor: 'class initialization' stamp: 'MU 11/5/2000 00:04'!
initialize
	
	default := nil.
	! !

!OperaSingleton class methodsFor: 'class initialization' stamp: 'MU 11/5/2000 00:05'!
initializeAll
	"OperaSingleton initializeAll"
	
	OperaSingleton allSubclassesDo:[:each | each initialize]
	! !


!OperaSingleton class methodsFor: 'instance creation' stamp: 'MU 11/5/2000 00:05'!
default
	default isNil ifTrue:[default := self new].
	^default! !

!OperaSingleton class methodsFor: 'instance creation' stamp: 'MU 11/5/2000 00:05'!
new
	^super new initialize! !


OperaSingleton subclass: #OperaConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaConnector commentStamp: 'MU 11/12/2000 01:33' prior: 0!
I connect to a Soap-Http Server and return results to stubs (RemoteObject).
Currently I do not support collocation.!


!OperaConnector methodsFor: 'sending' stamp: 'MU 11/12/2000 02:34'!
send: aRemoteMessageSend to: host port: port
	| url env ret |
	url := host, ':', port asString.
	env := self wrapSoapEnvelope: aRemoteMessageSend.
	ret := SoapHttpClient sendTo: url request: env printXmlString.
	"Transcript show: ret printString." "##for debug##"
	^self processReturn: ret.! !


!OperaConnector methodsFor: 'private' stamp: 'MU 11/10/2000 20:50'!
processReturn: aReturnedXmlString 
	| env msg |
	env := SoapEnvelope fromXml: aReturnedXmlString.
	env body hasFault
		ifTrue: [self signalErrorFrom: env body fault].
	msg := env body messages first. "currently only one msg support"
	
	^OperaObjectStream objectFromString: msg result! !

!OperaConnector methodsFor: 'private' stamp: 'MU 11/7/2000 20:06'!
signalErrorFrom: aSoapFault
	(SoapError fromSoapFault: aSoapFault) signal! !

!OperaConnector methodsFor: 'private' stamp: 'MU 11/10/2000 18:04'!
wrapSoapEnvelope: aRemoteMessageSend 
	| env msg |
	env := SoapEnvelope fromXml: self class templateEnvelopeXml.
	msg := env body messages first.
	"##more work will be needed##"
	"We need XML schema marshal/unmarshaller for true SOAP interoperability"
	msg name: OperaObjectAdapter dispatchSelectorName.
	msg receiver: OperaObjectAdapter serverName.
	msg
		arguments: (Array
				with: (SoapArgument name: aRemoteMessageSend class name asString value: aRemoteMessageSend storeString)).
	^ env! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaConnector class
	instanceVariableNames: ''!

!OperaConnector class methodsFor: 'constants' stamp: 'MU 11/7/2000 11:38'!
templateEnvelopeXml
	^'
<SOAP-ENV:Envelope
	xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
	<SOAP-ENV:Body>
		<m:selector xmlns:m="receiver">
			<symbol>value</symbol>
		</m:selector>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>
'.! !


OperaSingleton subclass: #OperaObjectAdapter
	instanceVariableNames: 'namedObjectHome '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaObjectAdapter commentStamp: 'MU 11/12/2000 01:34' prior: 0!
I am an object adapter for server.!


!OperaObjectAdapter methodsFor: 'initialize-release' stamp: 'MU 11/10/2000 17:32'!
initialize
	namedObjectHome := nil! !


!OperaObjectAdapter methodsFor: 'receiving' stamp: 'MU 11/12/2000 01:43'!
dispatch: aStringfiedRemoteMessageSend
	| message ret |
	message := (RemoteMessageSend fromString: aStringfiedRemoteMessageSend).
	message namedObjectHome: (self namedObjectHome).
	ret := RemoteReturnValue value: (message value).
	"##more work##"
	"##need to investigate return-by-value or return-by-ref##" 
	ret value == message receiver
	 ifTrue:[ ^ret value: 'a RemoteObject named: ', message receiverName]. 
		"restrict implicit self return - no object ref support - Squeak crashes if I return RemoteObject itself"
	^ret! !


!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/10/2000 13:44'!
at: aSymbol
	^ self namedObjectHome at: aSymbol! !

!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/10/2000 13:46'!
at: aSymbol ifAbsent: aBlock
	^ self namedObjectHome at: aSymbol ifAbsent: aBlock! !

!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/10/2000 13:47'!
at: aSymbol put: anObject 
	^ self namedObjectHome at: aSymbol put: anObject! !


!OperaObjectAdapter methodsFor: 'accessing' stamp: 'MU 11/10/2000 13:43'!
namedObjectHome
	namedObjectHome isNil ifTrue:[namedObjectHome := NamedObjectHome new].
	^namedObjectHome! !

!OperaObjectAdapter methodsFor: 'accessing' stamp: 'MU 11/10/2000 13:44'!
namedObjectHome: aNamedObjectHome
	namedObjectHome := aNamedObjectHome
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaObjectAdapter class
	instanceVariableNames: ''!

!OperaObjectAdapter class methodsFor: 'class initialization' stamp: 'MU 11/12/2000 02:17'!
initialize
	"OperaObjectAdapter initialize"
	self installRootOOA
	! !

!OperaObjectAdapter class methodsFor: 'class initialization' stamp: 'MU 11/10/2000 13:41'!
installRootOOA
	| acceptor soapBroker messageBinding |
	acceptor := self root.
	soapBroker := SoapBroker default export: acceptor as: (self serverName).
	messageBinding := SoapMessageBinding new.
	messageBinding name: (self dispatchSelectorName).
	messageBinding selector: #dispatch:.
	messageBinding addArgument: (SoapArgument
				name: 'RemoteMessageSend'
				dataType: (soapBroker dataTypeNamed: 'string')).
	soapBroker addBinding: messageBinding.
	! !


!OperaObjectAdapter class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 13:40'!
root
	"OperaObjectAdapter root"
	"Returns RootOOA"
	^super default! !


!OperaObjectAdapter class methodsFor: 'constants' stamp: 'MU 11/9/2000 13:16'!
dispatchSelectorName
	^'Dispatch'! !

!OperaObjectAdapter class methodsFor: 'constants' stamp: 'MU 11/9/2000 12:05'!
serverName
	^'RootOOA'! !


OperaSingleton subclass: #OperaSetting
	instanceVariableNames: 'defaultHost defaultPort '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaSetting commentStamp: 'MU 11/12/2000 01:39' prior: 0!
I have settings for SoapOpera. Default hostname, default port number, etc.!


!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:48'!
defaultHost
	defaultHost isNil ifTrue:[defaultHost := 'localhost'].
	^defaultHost! !

!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:47'!
defaultHost: aValue

	defaultHost := aValue! !

!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:49'!
defaultPort
	defaultPort isNil ifTrue:[defaultPort := 8823].
	^defaultPort! !

!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:47'!
defaultPort: aValue

	defaultPort := aValue! !


MessageSend subclass: #RemoteMessageSend
	instanceVariableNames: 'receiverName namedObjectHome '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!RemoteMessageSend commentStamp: 'MU 11/12/2000 01:47' prior: 0!
I am a MessageSend for RemoteObject

Instance variable names:
 receiverName <Symbol> 
 namedObjectHome <NamedObjectHome>
!


!RemoteMessageSend methodsFor: 'actions' stamp: 'MU 11/10/2000 21:06'!
receiver
	^(self receiverOf: self receiverName)! !


!RemoteMessageSend methodsFor: 'storing' stamp: 'MU 11/7/2000 17:04'!
storeString
	^OperaObjectStream stringFromObject: self! !


!RemoteMessageSend methodsFor: 'accessing' stamp: 'MU 11/10/2000 17:23'!
namedObjectHome
	namedObjectHome isNil ifTrue:[namedObjectHome := NamedObjectHome new].
	^namedObjectHome! !

!RemoteMessageSend methodsFor: 'accessing' stamp: 'MU 11/10/2000 17:22'!
namedObjectHome: aNamedObjectHome
	namedObjectHome := aNamedObjectHome! !

!RemoteMessageSend methodsFor: 'accessing' stamp: 'mu 10/30/2000 14:44'!
receiverName
	^receiverName! !

!RemoteMessageSend methodsFor: 'accessing' stamp: 'mu 10/30/2000 14:44'!
receiverName: anObjectNameSymbol
	receiverName := anObjectNameSymbol! !


!RemoteMessageSend methodsFor: 'evaluating' stamp: 'MU 11/10/2000 21:09'!
value
	| rawRet |
	rawRet := arguments isNil
		ifTrue: [self receiver perform: selector]
		ifFalse: [self receiver perform: selector withArguments: arguments].
	^rawRet! !


!RemoteMessageSend methodsFor: 'private' stamp: 'MU 11/10/2000 17:23'!
receiverOf: aObjectName
	^self namedObjectHome at: aObjectName! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RemoteMessageSend class
	instanceVariableNames: ''!

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'MU 11/7/2000 17:05'!
fromString: aString
	 ^OperaObjectStream objectFromString: aString.! !

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 14:46'!
receiverName: anObject selector: aSymbol
	^ self receiverName: anObject selector: aSymbol arguments: #()! !

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 14:46'!
receiverName: anObject selector: aSymbol argument: aParameter
	^ self receiverName: anObject selector: aSymbol arguments: (Array with: aParameter)! !

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 14:45'!
receiverName: anObject selector: aSymbol arguments: anArray
	^ self new
		receiverName: anObject;
		selector: aSymbol;
		arguments: anArray! !


!RemoteMessageSend class methodsFor: 'constants' stamp: 'MU 11/7/2000 14:41'!
tagName
	^self name! !


ProtoObject subclass: #RemoteObject
	instanceVariableNames: 'name host port '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!RemoteObject commentStamp: 'MU 11/12/2000 01:49' prior: 0!
I am a stub for client.

Instance variable names:
 name <Symbol> object name
 host <String> server host where object imple lives
 port <Integer> server port where object imple lives!


!RemoteObject methodsFor: 'system callback' stamp: 'MU 11/10/2000 20:41'!
doesNotUnderstand: aMessage

	| remoteMsg |
	remoteMsg := RemoteMessageSend receiverName: self oprName selector: aMessage selector arguments: aMessage arguments.
	
	^OperaConnector default send: remoteMsg to: self oprHost port: self oprPort! !


!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/6/2000 00:40'!
oprHost
	host isNil ifTrue:[host := OperaSetting default defaultHost].
	^host! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:21'!
oprHost: aValue

	host := aValue! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:22'!
oprName
	name isNil ifTrue:[name := 'server'].
	^name! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:22'!
oprName: aValue

	name := aValue! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/6/2000 00:40'!
oprPort
	port isNil ifTrue:[port := OperaSetting default defaultPort].
	^port	! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:22'!
oprPort: aValue

	port := aValue! !


!RemoteObject methodsFor: 'special' stamp: 'MU 11/6/2000 00:47'!
halt
	"useful for debug"

	Halt signal! !

!RemoteObject methodsFor: 'special' stamp: 'MU 11/7/2000 20:22'!
inspect
	"useful for debug"
	| dic |
	dic := IdentityDictionary new.
	dic at: #ClassName put: #RemoteObject.
	dic at: #name put: self oprName.
	dic at: #host put: self oprHost.
	dic at: #port put: self oprPort.
	Inspector openOn:  dic withEvalPane: true withLabel: ('a RemoteObject: ', (self oprName)) asSymbol! !

!RemoteObject methodsFor: 'special' stamp: 'MU 11/6/2000 00:48'!
yourself
	"for optimization"

	^self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RemoteObject class
	instanceVariableNames: ''!

!RemoteObject class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:42'!
name: aSymbol host: aHost 
	^self name: aSymbol host: aHost port: nil! !

!RemoteObject class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:42'!
name: aSymbol host: aHost port: aPort 
	| inst |
	inst := self new.
	inst oprName: aSymbol.
	inst oprHost: aHost.
	inst oprPort: aPort.
	^inst! !

!RemoteObject class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:43'!
named: aSymbol
	^self name: aSymbol host: nil! !


Object subclass: #RemoteReturnValue
	instanceVariableNames: 'value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!RemoteReturnValue commentStamp: 'MU 11/12/2000 01:49' prior: 0!
I encaptulate return value for wire passing.

!


!RemoteReturnValue methodsFor: 'storing' stamp: 'MU 11/10/2000 20:18'!
storeString
	^OperaObjectStream stringFromObject: self value! !


!RemoteReturnValue methodsFor: 'accessing' stamp: 'mu 10/30/2000 15:15'!
value
	^value! !

!RemoteReturnValue methodsFor: 'accessing' stamp: 'mu 10/30/2000 15:16'!
value: aValue
	value := aValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RemoteReturnValue class
	instanceVariableNames: ''!

!RemoteReturnValue class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 20:12'!
fromString: aString
	  ^self value: (OperaObjectStream objectFromString: aString)! !

!RemoteReturnValue class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 15:16'!
value: aValue
	^self new value: aValue! !


Object subclass: #SoapOperaDoc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapOperaDoc class
	instanceVariableNames: ''!

!SoapOperaDoc class methodsFor: 'documentation' stamp: 'MU 11/12/2000 23:47'!
aboutSoapOpera
"## SoapOpera ## 
SoapOpera is a tiny ORB based on Soap-Http Protocol.

-Prerequisites:

 - VW XML Parser ported by Bijan Parsia(http://minnow.cc.gatech.edu/squeak/1408)
 - A refactored SOAP implementation 
        (included in this release)
        (but original is CS2 SOAP implementation. 
         http://wiki.cs.uiuc.edu/CampSmalltalk/SOAP+Smalltalk+Reference+Implementation)
 - ComSwiki (http://minnow.cc.gatech.edu/swiki)

Enjoy!!

---
[:masashi | ^umezawa] 11/12/2000
"! !


!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/12/2000 02:23'!
example1
	"SoapOperaDoc example1"
	
	"##Server side##"
	" 0: open transcript(to see the results)"

	" 1: start soap-http server"
	SoapHttpModuleSetup launch.
	
	" 2: init object adapter ( may be unneeded because file-in do this automatically)"
	OperaObjectAdapter initialize.
	
	" 3: register object implementation"
	OperaObjectAdapter root at: #John put: Cs2Person new.
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/12/2000 02:38'!
example2
	| john ret |
	"SoapOperaDoc example2"
	
	"##Client side##"
	" 0: open transcript(to see the results)"

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: remote message send"
	ret := john doSomething: 'Smalltalk!!!!'.
	
	" 3: remote message send (causes error)"
	"john add: #fooBarBaz"
	
	Transcript cr; show: ret printString. "change Cs2Person >> doSomething: return values"
	^ret! !

OperaSingleton initialize!
OperaObjectAdapter initialize!